//
//  THSIconPanel.java
//  treehousedraw_max
//
//  Created by Maxwell Planck on Fri Oct 25 2002.
//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
//

import java.awt.*;
import java.applet.*;
import java.util.*;
import java.awt.image.*;

/**
 * This THSPanel holds the tool menu for selecting what kind of painting tool one wants
 * to use
 */

class THSIconPanel extends THSPanel // icon area
{

    /***********************************************************************************
    ************************************************************************************
    ************************************************************************************
    **
    ** All of the following code can be modified to update the current Tree House Studio
    ** Applet so functionality can be added to the THSIconPanel
    **
    ************************************************************************************
    ************************************************************************************
    ************************************************************************************/
    
    public void initTools() {
        this.addTool(new LineTool());
        this.addTool(new TypeTool());
        this.addTool(new FillTool());
        this.addTool(new PencilTool());
        this.addTool(new BrushTool());
        this.addTool(new EraserTool());
        this.addTool(new SprayCanTool());
        this.addTool(new RectTool());
        this.addTool(new FilledRectTool());
        this.addTool(new OvalTool());
        this.addTool(new FilledOvalTool());
        this.addTool(new BlobTool());
        this.addTool(new FilledBlobTool());
        this.addTool(new PolygonTool());
        this.addTool(new FilledPolygonTool());
        /*this.addIcon("painticon-1_blob.gif", BLOB);
        this.addIcon("painticon-1_brush.gif", BRUSH);
        this.addIcon("painticon-1_bucket.gif", BUCKET);
        this.addIcon("painticon-1_circle.gif", OVAL);
        this.addIcon("painticon-1_eraser.gif", ERASER);
        this.addIcon("painticon-1_fblob.gif", FBLOB);
        this.addIcon("painticon-1_fcircle.gif", OVALFILL);
        this.addIcon("painticon-1_fpoly.gif", FPOLY);
        this.addIcon("painticon-1_frect.gif", RECTFILL);
        this.addIcon("painticon-1_frerect.gif", FRERECT);
        this.addIcon("painticon-1_hand.gif", HAND);
        this.addIcon("painticon-1_lasso.gif", LASSO);
        this.addIcon("painticon-1_line.gif", LINE);
        this.addIcon("painticon-1_pencil.gif", PENCIL);
        this.addIcon("painticon-1_poly.gif", POLY);
        this.addIcon("painticon-1_rect.gif", RECT);
        this.addIcon("painticon-1_rerect.gif", RERECT);
        this.addIcon("painticon-1_spraycan.gif", SPRAY);
        this.addIcon("painticon-1_type.gif", TYPE);
        this.addIcon("painticon-1_marquee.gif", MARQUEE);*/
    }
    

    /************************************************************************************
    ************************************************************************************
    ************************************************************************************
    **
    ** Everything else beyond this point is internal and shouldn't be changed unless
    ** you want to change an underlying aspect of the Applet.  Do use the rest of this code
    ** to understand how to add to the Applet.
    **
    ************************************************************************************
    ************************************************************************************
    ************************************************************************************/
    
    Applet app;
    
    //   final static String icons[] =
    int rows, cols;
    final int iconW = 27, iconH = 23;
    
    int selx = 1, sely = 1;
    int touchedToolind;
    public Vector tools;
    public THSGeneralTool selectedTool;
    
    long lastt=0;
    int lastsel;

    MediaTracker mt;
    Vector icons;
    Vector iconStrings;

    boolean[] enabledTools;
    int toolcount = 0;
    
    public THSIconPanel(int _x, int _y, int _w, int _h, int _type, Applet _app)
    {
        super("Icon Panel",_x,_y,_w,_h);
        app = _app;
        mt = new MediaTracker(app);

        tools = new Vector();
        iconStrings = new Vector();
        initTools();
        
        enabledTools = new boolean[toolcount];
        
        for (int i = 0; i < enabledTools.length; i++) {
            enabledTools[i] = true;
        }

        icons = retrieveIcons();
        cols = 2; // restricts the row count
        rows = (int) Math.ceil(icons.size()/2.0); //as many rows as are needed

        // This updates the super variables
        ch = rows*iconH;
        cw = cols*iconW;

        disableTool(9);
        disableTool(12);
        disableTool(14);
    }

    public THSGeneralTool getSelectedTool() {
        return selectedTool;
    }
    

    public void disableTool(int ind) {
        enabledTools[ind] = false;
        Image im = (Image) icons.elementAt(ind);
        GrayFilter filter = new GrayFilter();
        im = app.createImage(new FilteredImageSource(im.getSource(), filter));
//        icons.set(ind, im);
        icons.setElementAt(im, ind);
    }

    public void addTool(THSGeneralTool tool) {
        tools.addElement(tool);
        toolcount++;
    }

    public void setFirstTool() {
        int pickedTool = 1; //Pencil
        selx = pickedTool%cols;
        sely = pickedTool/cols;
        if (target != null) {
            target.message("Icon Panel", tools.elementAt(pickedTool));
        } else {
            throw new RuntimeException("An initial tool must be initialized within the Treehousestudio class");
        }
    }


    // Don't mind the methods behind this line
    // -----------------------------------------
    private Vector retrieveIcons() {
        Vector res = new Vector();
        for (int i = 0; i < tools.size(); i++) {
            String icon = ((THSGeneralTool) tools.elementAt(i)).getIconImage();
            Image im = app.getImage(app.getCodeBase(), "icons/" + icon);
            im = im.getScaledInstance(iconW,iconH,Image.SCALE_SMOOTH);
            if (im.getHeight(app) != -1) {
                throw new RuntimeException("The icon referring to image " + icon + " was not loaded properly");
            }
            mt.addImage(im,i);
            res.addElement(im);
        }

        try {
            mt.waitForAll();
        } catch (Exception e) {
            e.printStackTrace();
        }

        return res;
    }

    public void draw(Graphics g) {
        for (int i = 0; i < icons.size(); i++) {
            if (icons.elementAt(i) != null) {
                Image currImage = (Image) icons.elementAt(i);
                g.drawImage(currImage,cx+(i%2*(iconW)),cy+(int) (Math.floor(i/2))*(iconH), app);
            }
        }
        g.setColor(Color.blue);
        g.drawRect(cx+1+selx*iconW,cy+1+sely*iconH,iconW-3,iconH-3);
    }
    
    public void mouseDown(Event ev, int mx, int my) {
        int tempsely, tempselx, tempTouchedToolind;
        mx-=cx; my-=cy;
        // assign temporary values until it is determined that the selection is valid
        tempsely = Math.min(my/iconH, rows-1);
        tempselx = Math.min(mx/iconW, cols-1);
        tempTouchedToolind = tempselx+tempsely*cols;
        try {
            THSGeneralTool touchedTool = (THSGeneralTool) tools.elementAt(tempTouchedToolind);
            if ((!enabledTools[tempTouchedToolind]) || (touchedTool == null)) {
                return; // the tool is disabled or not there
            }
            // This tool can be selected- assign over all temporary values
            selectedTool = touchedTool;
            touchedToolind = tempTouchedToolind;
            selx = tempselx;
            sely = tempsely;

            long t = System.currentTimeMillis();

            if (t-lastt<500 && lastsel == touchedToolind) {
                target.message("Doubleclick", selectedTool);
            } else
                target.message("Icon Panel", selectedTool);
            lastt = t;
            lastsel = touchedToolind;
            
        } catch (ArrayIndexOutOfBoundsException e) {
            return; // there is not tool at this blank spot
        }
    }

    public void mouseDrag(Event ev, int mx, int my) {}
    public void mouseUp(Event ev, int mx, int my) {}

    public boolean keyDown(Event ev, int k) {
        return false;
    }

    public void message(String fromWho, Object odat) {}


    class GrayFilter extends RGBImageFilter {
        public GrayFilter() {
            // The filter's operation does not depend on the
            // pixel's location, so IndexColorModels can be
            // filtered directly.
            canFilterIndexColorModel = true;
        }
        
        public int filterRGB(int x, int y, int rgb) {
            return ((rgb & 0x4f4f4fff));
        }
    }
}

