//
//  paintbrush.java
//  Treehousestudio
//
//  Created by Maxwell Planck on Tue Nov 26 2002.
//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
//

import java.awt.*;
import java.applet.*;
import java.awt.image.*;

/**
 * This abstract class is the template for a paintbrush.  Simply, a paintbrush is a tool that leaves a mark
 * of particular size and type on the canvas whenever it's paint method is called at a specified location.
 */
public abstract class paintbrush {
    int sz;

    public paintbrush(int _sz) {
        setsize(_sz);
    }
    
    public paintbrush setsize(int s) {
        sz = s;
        return this;
    }

    public abstract void paint(Graphics g, int x, int y);
}

/**
 * This is the simplest kind of brush- a squarebrush that draws of square of particular size when it's paint
 * method is called
 */
class squarebrush extends paintbrush {

    public squarebrush(int _n) {
        super(_n);
    }
    
    public void paint(Graphics g, int x, int y) {
        g.fillRect(x,y,sz,sz);
    }
    
}

/**
 * This paintbrush places an image at the location the that paint is called.  The image drawn is specified once the
 * brush is instantiated.
 */
class imbrush extends paintbrush {
    int n;
    Applet app;
    Image im;

    public imbrush(int _n,Image _im,Applet _app)
    {
        super(_n);
        im = _im;app =_app;
    }

    public void paint(Graphics g, int x, int y)
    {
        g.drawImage(im,x,y,app);
    }
}

/**
 * This is a roundbrush- a round filled circle is drawn whenever the paint method is called
 */
class roundbrush extends paintbrush {
    int n;

    public roundbrush(int _n)
    {
        super(_n);
    }
    public void paint(Graphics g, int x, int y)
    {
        g.fillOval(x,y,sz,sz);
    }
}
